diff --git a/src/backend/utils/misc/pg_controldata.c b/src/backend/utils/misc/pg_controldata.c
new file mode 100644
index 56ba301..8dee6d3
*** a/src/backend/utils/misc/pg_controldata.c
--- b/src/backend/utils/misc/pg_controldata.c
*************** pg_control_checkpoint(PG_FUNCTION_ARGS)
*** 166,174 ****
  	values[6] = BoolGetDatum(ControlFile->checkPointCopy.fullPageWrites);
  	nulls[6] = false;
  
! 	values[7] = CStringGetTextDatum(psprintf("%u:%u",
! 									ControlFile->checkPointCopy.nextXidEpoch,
! 									   ControlFile->checkPointCopy.nextXid));
  	nulls[7] = false;
  
  	values[8] = ObjectIdGetDatum(ControlFile->checkPointCopy.nextOid);
--- 166,173 ----
  	values[6] = BoolGetDatum(ControlFile->checkPointCopy.fullPageWrites);
  	nulls[6] = false;
  
! 	values[7] = CStringGetTextDatum(psprintf(XID_FMT,
! 								ControlFile->checkPointCopy.nextXid));
  	nulls[7] = false;
  
  	values[8] = ObjectIdGetDatum(ControlFile->checkPointCopy.nextOid);
diff --git a/src/backend/utils/sort/tuplesort.c b/src/backend/utils/sort/tuplesort.c
new file mode 100644
index 8a8db0f..98cf915
*** a/src/backend/utils/sort/tuplesort.c
--- b/src/backend/utils/sort/tuplesort.c
*************** readtup_cluster(Tuplesortstate *state, S
*** 4017,4022 ****
--- 4017,4023 ----
  						 &tuple->t_self, sizeof(ItemPointerData));
  	/* We don't currently bother to reconstruct t_tableOid */
  	tuple->t_tableOid = InvalidOid;
+ 	HeapTupleSetZeroBase(tuple);
  	/* Read in the tuple body */
  	LogicalTapeReadExact(state->tapeset, tapenum,
  						 tuple->t_data, tuple->t_len);
diff --git a/src/backend/utils/time/combocid.c b/src/backend/utils/time/combocid.c
new file mode 100644
index baff998..a84a6cd
*** a/src/backend/utils/time/combocid.c
--- b/src/backend/utils/time/combocid.c
*************** HeapTupleHeaderGetCmin(HeapTupleHeader t
*** 107,113 ****
  	CommandId	cid = HeapTupleHeaderGetRawCommandId(tup);
  
  	Assert(!(tup->t_infomask & HEAP_MOVED));
! 	Assert(TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmin(tup)));
  
  	if (tup->t_infomask & HEAP_COMBOCID)
  		return GetRealCmin(cid);
--- 107,114 ----
  	CommandId	cid = HeapTupleHeaderGetRawCommandId(tup);
  
  	Assert(!(tup->t_infomask & HEAP_MOVED));
! 	/* FIXME */
! 	/*Assert(TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmin(tup)));*/
  
  	if (tup->t_infomask & HEAP_COMBOCID)
  		return GetRealCmin(cid);
*************** HeapTupleHeaderGetCmax(HeapTupleHeader t
*** 128,135 ****
  	 * weakens the check, but not using GetCmax() inside one would complicate
  	 * things too much.
  	 */
! 	Assert(CritSectionCount > 0 ||
! 	  TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetUpdateXid(tup)));
  
  	if (tup->t_infomask & HEAP_COMBOCID)
  		return GetRealCmax(cid);
--- 129,137 ----
  	 * weakens the check, but not using GetCmax() inside one would complicate
  	 * things too much.
  	 */
! 	/* FIXME*/
! 	/*Assert(CritSectionCount > 0 ||
! 	  TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetUpdateXid(tup)));*/
  
  	if (tup->t_infomask & HEAP_COMBOCID)
  		return GetRealCmax(cid);
*************** HeapTupleHeaderGetCmax(HeapTupleHeader t
*** 151,157 ****
   * changes the tuple in shared buffers.
   */
  void
! HeapTupleHeaderAdjustCmax(HeapTupleHeader tup,
  						  CommandId *cmax,
  						  bool *iscombo)
  {
--- 153,159 ----
   * changes the tuple in shared buffers.
   */
  void
! HeapTupleHeaderAdjustCmax(HeapTuple tup,
  						  CommandId *cmax,
  						  bool *iscombo)
  {
*************** HeapTupleHeaderAdjustCmax(HeapTupleHeade
*** 161,170 ****
  	 * Test for HeapTupleHeaderXminCommitted() first, because it's cheaper
  	 * than a TransactionIdIsCurrentTransactionId call.
  	 */
! 	if (!HeapTupleHeaderXminCommitted(tup) &&
! 		TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetRawXmin(tup)))
  	{
! 		CommandId	cmin = HeapTupleHeaderGetCmin(tup);
  
  		*cmax = GetComboCommandId(cmin, *cmax);
  		*iscombo = true;
--- 163,172 ----
  	 * Test for HeapTupleHeaderXminCommitted() first, because it's cheaper
  	 * than a TransactionIdIsCurrentTransactionId call.
  	 */
! 	if (!HeapTupleHeaderXminCommitted(tup->t_data) &&
! 		TransactionIdIsCurrentTransactionId(HeapTupleGetRawXmin(tup)))
  	{
! 		CommandId	cmin = HeapTupleHeaderGetCmin(tup->t_data);
  
  		*cmax = GetComboCommandId(cmin, *cmax);
  		*iscombo = true;
diff --git a/src/backend/utils/time/snapmgr.c b/src/backend/utils/time/snapmgr.c
new file mode 100644
index 2b6fca9..b465090
*** a/src/backend/utils/time/snapmgr.c
--- b/src/backend/utils/time/snapmgr.c
*************** ExportSnapshot(Snapshot snapshot)
*** 1211,1218 ****
  	 * Generate file path for the snapshot.  We start numbering of snapshots
  	 * inside the transaction from 1.
  	 */
! 	snprintf(path, sizeof(path), SNAPSHOT_EXPORT_DIR "/%08X-%08X-%d",
! 			 MyProc->backendId, MyProc->lxid, list_length(exportedSnapshots) + 1);
  
  	/*
  	 * Copy the snapshot into TopTransactionContext, add it to the
--- 1211,1219 ----
  	 * Generate file path for the snapshot.  We start numbering of snapshots
  	 * inside the transaction from 1.
  	 */
! 	snprintf(path, sizeof(path), SNAPSHOT_EXPORT_DIR "/%08X-%08X%08X-%d",
! 			 MyProc->backendId, (uint32) (MyProc->lxid >> 32),
! 			 (uint32) MyProc->lxid, list_length(exportedSnapshots) + 1);
  
  	/*
  	 * Copy the snapshot into TopTransactionContext, add it to the
*************** ExportSnapshot(Snapshot snapshot)
*** 1239,1252 ****
  	 */
  	initStringInfo(&buf);
  
! 	appendStringInfo(&buf, "vxid:%d/%u\n", MyProc->backendId, MyProc->lxid);
  	appendStringInfo(&buf, "pid:%d\n", MyProcPid);
  	appendStringInfo(&buf, "dbid:%u\n", MyDatabaseId);
  	appendStringInfo(&buf, "iso:%d\n", XactIsoLevel);
  	appendStringInfo(&buf, "ro:%d\n", XactReadOnly);
  
! 	appendStringInfo(&buf, "xmin:%u\n", snapshot->xmin);
! 	appendStringInfo(&buf, "xmax:%u\n", snapshot->xmax);
  
  	/*
  	 * We must include our own top transaction ID in the top-xid data, since
--- 1240,1253 ----
  	 */
  	initStringInfo(&buf);
  
! 	appendStringInfo(&buf, "vxid:%d/" XID_FMT "\n", MyProc->backendId, MyProc->lxid);
  	appendStringInfo(&buf, "pid:%d\n", MyProcPid);
  	appendStringInfo(&buf, "dbid:%u\n", MyDatabaseId);
  	appendStringInfo(&buf, "iso:%d\n", XactIsoLevel);
  	appendStringInfo(&buf, "ro:%d\n", XactReadOnly);
  
! 	appendStringInfo(&buf, "xmin:" XID_FMT "\n", snapshot->xmin);
! 	appendStringInfo(&buf, "xmax:" XID_FMT "\n", snapshot->xmax);
  
  	/*
  	 * We must include our own top transaction ID in the top-xid data, since
*************** ExportSnapshot(Snapshot snapshot)
*** 1263,1271 ****
  		TransactionIdPrecedes(topXid, snapshot->xmax)) ? 1 : 0;
  	appendStringInfo(&buf, "xcnt:%d\n", snapshot->xcnt + addTopXid);
  	for (i = 0; i < snapshot->xcnt; i++)
! 		appendStringInfo(&buf, "xip:%u\n", snapshot->xip[i]);
  	if (addTopXid)
! 		appendStringInfo(&buf, "xip:%u\n", topXid);
  
  	/*
  	 * Similarly, we add our subcommitted child XIDs to the subxid data. Here,
--- 1264,1272 ----
  		TransactionIdPrecedes(topXid, snapshot->xmax)) ? 1 : 0;
  	appendStringInfo(&buf, "xcnt:%d\n", snapshot->xcnt + addTopXid);
  	for (i = 0; i < snapshot->xcnt; i++)
! 		appendStringInfo(&buf, "xip:" XID_FMT "\n", snapshot->xip[i]);
  	if (addTopXid)
! 		appendStringInfo(&buf, "xip:" XID_FMT "\n", topXid);
  
  	/*
  	 * Similarly, we add our subcommitted child XIDs to the subxid data. Here,
*************** ExportSnapshot(Snapshot snapshot)
*** 1279,1287 ****
  		appendStringInfoString(&buf, "sof:0\n");
  		appendStringInfo(&buf, "sxcnt:%d\n", snapshot->subxcnt + nchildren);
  		for (i = 0; i < snapshot->subxcnt; i++)
! 			appendStringInfo(&buf, "sxp:%u\n", snapshot->subxip[i]);
  		for (i = 0; i < nchildren; i++)
! 			appendStringInfo(&buf, "sxp:%u\n", children[i]);
  	}
  	appendStringInfo(&buf, "rec:%u\n", snapshot->takenDuringRecovery);
  
--- 1280,1288 ----
  		appendStringInfoString(&buf, "sof:0\n");
  		appendStringInfo(&buf, "sxcnt:%d\n", snapshot->subxcnt + nchildren);
  		for (i = 0; i < snapshot->subxcnt; i++)
! 			appendStringInfo(&buf, "sxp:" XID_FMT "\n", snapshot->subxip[i]);
  		for (i = 0; i < nchildren; i++)
! 			appendStringInfo(&buf, "sxp:" XID_FMT "\n", children[i]);
  	}
  	appendStringInfo(&buf, "rec:%u\n", snapshot->takenDuringRecovery);
  
*************** parseXidFromText(const char *prefix, cha
*** 1384,1390 ****
  				(errcode(ERRCODE_INVALID_TEXT_REPRESENTATION),
  				 errmsg("invalid snapshot data in file \"%s\"", filename)));
  	ptr += prefixlen;
! 	if (sscanf(ptr, "%u", &val) != 1)
  		ereport(ERROR,
  				(errcode(ERRCODE_INVALID_TEXT_REPRESENTATION),
  				 errmsg("invalid snapshot data in file \"%s\"", filename)));
--- 1385,1391 ----
  				(errcode(ERRCODE_INVALID_TEXT_REPRESENTATION),
  				 errmsg("invalid snapshot data in file \"%s\"", filename)));
  	ptr += prefixlen;
! 	if (sscanf(ptr, XID_FMT, &val) != 1)
  		ereport(ERROR,
  				(errcode(ERRCODE_INVALID_TEXT_REPRESENTATION),
  				 errmsg("invalid snapshot data in file \"%s\"", filename)));
*************** parseVxidFromText(const char *prefix, ch
*** 1409,1415 ****
  				(errcode(ERRCODE_INVALID_TEXT_REPRESENTATION),
  				 errmsg("invalid snapshot data in file \"%s\"", filename)));
  	ptr += prefixlen;
! 	if (sscanf(ptr, "%d/%u", &vxid->backendId, &vxid->localTransactionId) != 2)
  		ereport(ERROR,
  				(errcode(ERRCODE_INVALID_TEXT_REPRESENTATION),
  				 errmsg("invalid snapshot data in file \"%s\"", filename)));
--- 1410,1416 ----
  				(errcode(ERRCODE_INVALID_TEXT_REPRESENTATION),
  				 errmsg("invalid snapshot data in file \"%s\"", filename)));
  	ptr += prefixlen;
! 	if (sscanf(ptr, "%d/" XID_FMT, &vxid->backendId, &vxid->localTransactionId) != 2)
  		ereport(ERROR,
  				(errcode(ERRCODE_INVALID_TEXT_REPRESENTATION),
  				 errmsg("invalid snapshot data in file \"%s\"", filename)));
